質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.96%

read_csvで読み込んだはずのヘッダが認識されない

解決済

回答 2

投稿

  • 評価
  • クリップ 0
  • VIEW 823

_hh

score 46

Pythonのjupyter notebookで、あるcsvを読み込み、回帰分析したく考えております。
しかし、read_csvで読み込み、下記のコードの様に変数を読み込もうとしますと、エラーが出ます。
d.head()で表示しますと、確かにヘッダに'shares'の文字はあるのですが、不思議なことに、なぜか下記のコードで読み込めません。
原因と対応につき、何かございましたら、ご教示下さい。

【環境】Windows10, 64bit, chrome

コード

import pandas as pd
import numpy as np
import scipy as sp
import scipy.stats as stats
import statsmodels.api as sm
import statsmodels.formula.api as smf

d = pd.read_csv('OnlineNewsPopularity.csv', sep=',')
y=d[['shares']]
X=d[['timedelta']]

エラー表示

KeyError                                  Traceback (most recent call last)
<ipython-input-33-9be03f2e23e5> in <module>()
8 #IV selection.
9 d = pd.read_csv('OnlineNewsPopularity.csv', sep=',')
---> 10 y=d[['shares']]
11 X=d[['timedelta']]
12 

~\Miniconda3\envs\stats\lib\site-packages\pandas\core\frame.py in getitem(self, key)
2680         if isinstance(key, (Series, np.ndarray, Index, list)):
2681             # either boolean or fancy integer index
-> 2682             return self._getitem_array(key)
2683         elif isinstance(key, DataFrame):
2684             return self._getitem_frame(key)

~\Miniconda3\envs\stats\lib\site-packages\pandas\core\frame.py in _getitem_array(self, key)
2724             return self._take(indexer, axis=0)
2725         else:
-> 2726             indexer = self.loc._convert_to_indexer(key, axis=1)
2727             return self._take(indexer, axis=1)
2728 

~\Miniconda3\envs\stats\lib\site-packages\pandas\core\indexing.py in _convert_to_indexer(self, obj, axis, is_setter)
1325                 if mask.any():
1326                     raise KeyError('{mask} not in index'
-> 1327                                    .format(mask=objarr[mask]))
1328 
1329                 return com._values_from_object(indexer)

KeyError: "['shares'] not in index"

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

checkベストアンサー

+2

(1) Column Labelの前後にスペースなどが含まれておりませんか?

print(df.columns)

にて確認してみてください。

(2) Column Index(列番号) で指定したらどうなりますか

df.iloc[:, [2]] #← 左から3行目

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/11/02 14:51

    有難うございます。スペースが入っておりましたので、その通りにして読み込んだところ、エラーが出なくなりました。

    キャンセル

0

y=d[['shares']]y=d['shares']としてください。[]は不要です。

 magichanさんの指摘を受け修正

失礼しました。上記の記載は正しいです。

元データはOnlineNewsPopularity.csvでしょうか?
であればurl, timedelta, n_tokens~のようにカンマ区切りの後ろに空白が入ってしまっており、列名やデータが「 shares」など空白入りで読み込まれてしまっています。
この空白を除去するため、d = pd.read_csv('OnlineNewsPopularity.csv', sep=',', skipinitialspace=True)として読み込んでください。

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/11/02 14:38

    有難うございます。しかし、以下の様なエラーとなりました:
    KeyError Traceback (most recent call last)
    ~\Miniconda3\envs\stats\lib\site-packages\pandas\core\indexes\base.py in get_loc(self, key, method, tolerance)
    3063 try:
    -> 3064 return self._engine.get_loc(key)
    3065 except KeyError:

    pandas/_libs/index.pyx in pandas._libs.index.IndexEngine.get_loc()

    pandas/_libs/index.pyx in pandas._libs.index.IndexEngine.get_loc()

    pandas/_libs/hashtable_class_helper.pxi in pandas._libs.hashtable.PyObjectHashTable.get_item()

    pandas/_libs/hashtable_class_helper.pxi in pandas._libs.hashtable.PyObjectHashTable.get_item()

    KeyError: 'shares'

    During handling of the above exception, another exception occurred:

    KeyError Traceback (most recent call last)
    <ipython-input-35-a9745710bbfb> in <module>()
    8 #IV selection.
    9 d = pd.read_csv('OnlineNewsPopularity.csv', sep=',')
    ---> 10 y=d['shares']
    11
    12 #print(X.shape)

    ~\Miniconda3\envs\stats\lib\site-packages\pandas\core\frame.py in __getitem__(self, key)
    2686 return self._getitem_multilevel(key)
    2687 else:
    -> 2688 return self._getitem_column(key)
    2689
    2690 def _getitem_column(self, key):

    ~\Miniconda3\envs\stats\lib\site-packages\pandas\core\frame.py in _getitem_column(self, key)
    2693 # get column
    2694 if self.columns.is_unique:
    -> 2695 return self._get_item_cache(key)
    2696
    2697 # duplicate columns & possible reduce dimensionality

    ~\Miniconda3\envs\stats\lib\site-packages\pandas\core\generic.py in _get_item_cache(self, item)
    2484 res = cache.get(item)
    2485 if res is None:
    -> 2486 values = self._data.get(item)
    2487 res = self._box_item_values(item, values)
    2488 cache[item] = res

    ~\Miniconda3\envs\stats\lib\site-packages\pandas\core\internals.py in get(self, item, fastpath)
    4113
    4114 if not isna(item):
    -> 4115 loc = self.items.get_loc(item)
    4116 else:
    4117 indexer = np.arange(len(self.items))[isna(self.items)]

    ~\Miniconda3\envs\stats\lib\site-packages\pandas\core\indexes\base.py in get_loc(self, key, method, tolerance)
    3064 return self._engine.get_loc(key)
    3065 except KeyError:
    -> 3066 return self._engine.get_loc(self._maybe_cast_indexer(key))
    3067
    3068 indexer = self.get_indexer([key], method=method, tolerance=tolerance)

    pandas/_libs/index.pyx in pandas._libs.index.IndexEngine.get_loc()

    pandas/_libs/index.pyx in pandas._libs.index.IndexEngine.get_loc()

    pandas/_libs/hashtable_class_helper.pxi in pandas._libs.hashtable.PyObjectHashTable.get_item()

    pandas/_libs/hashtable_class_helper.pxi in pandas._libs.hashtable.PyObjectHashTable.get_item()

    KeyError: 'shares'

    キャンセル

  • 2018/11/02 14:46

    結果を Series ではなく DataFrame として得たい場合は [] は必要なのでは

    キャンセル

  • 2018/11/02 14:55

    ご指摘ありがとうございます。まさにその通りです…
    データおよび読み取り処理に問題あるので回答修正しました。

    キャンセル

  • 2018/11/02 14:58

    皆様有難うございます。読み込んだヘッダのスペースも無くすことができ、目的の操作ができるようになりました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.96%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る